import { __assign, __read } from "tslib";
/* eslint-disable func-names */
import { create } from 'mutative';
import { storeKey, identifierKey, usm, enablePatchesKey, strictKey, } from '../constant';
import { getStagedState, setStagedState } from '../utils/index';
export var action = function (target, key, descriptor) {
    var fn = descriptor.value;
    if (typeof fn === 'undefined') {
        throw new Error("".concat(String(key), " decorate error with '@action'."));
    }
    var value = function () {
        var _a;
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof getStagedState() === 'undefined') {
            try {
                var lastState = this[storeKey].getState();
                var state = void 0;
                var patches = [];
                var inversePatches = [];
                var recipe = function (draftState) {
                    setStagedState(draftState);
                    fn.apply(_this, args);
                };
                var enablePatches = this[enablePatchesKey];
                var strict = this[strictKey];
                if (enablePatches) {
                    _a = __read(create(lastState, recipe, {
                        enablePatches: true,
                        strict: strict,
                        enableAutoFreeze: strict,
                    }), 3), state = _a[0], patches = _a[1], inversePatches = _a[2];
                }
                else {
                    state = create(lastState, recipe, {
                        strict: strict,
                        enableAutoFreeze: strict,
                    });
                }
                setStagedState(undefined);
                if (__DEV__ && lastState === state) {
                    console.warn("There are no state updates to method ".concat(fn.name));
                }
                this[storeKey].dispatch(__assign({ type: this[identifierKey], method: key, params: args, _state: state, _usm: usm }, (enablePatches
                    ? {
                        _patches: patches,
                        _inversePatches: inversePatches,
                    }
                    : {})));
            }
            finally {
                setStagedState(undefined);
            }
        }
        else {
            // enable staged state mode.
            fn.apply(this, args);
        }
    };
    return __assign(__assign({}, descriptor), { value: value });
};
//# sourceMappingURL=action.js.map